/*******************************************************************************
*  D/ARo[^I2CŐڑĐ䂷TvvOP                    *
*                                                                              *
*  :DACMCP4725z肵vOłADACVOUTɂLEDzĂB *
*       ́AdONLED_(2.5V)5bS_(5V)5bI      *
*       DACEEPROMɏގ͍sĂ܂AR}h"Fast Mode"݂̂łB *
*       "skI2Clib.h"̓}`}X^[ΉłÃvO͖ΉȂ̂   *
*       }`}X^[͕słB                                         *
*                                                                              *
* ============================================================================ *
*  VERSION DATE        BY                    CHANGE/COMMENT                    *
* ---------------------------------------------------------------------------- *
*  1.00    2014-12-24  ޒH[(ނ)  Create                            *
*  1.10    2015-10-30  ޒH[(ނ)  skI2ClibύXɂΉ            *
* ============================================================================ *
*  PIC 12F1822                                                                 *
*  MPLAB X(v2.15)                                                              *
*  MPLAB(R) XC8 C Compiler Version 1.32                                        *
*******************************************************************************/
#include <xc.h>
#include "skI2Clib.h"

#define DAC_ADRES  0x61            // D/ARo[^̃AhX(A0=HIGH)
#define _XTAL_FREQ 8000000         // gpPICɂ蓮glݒ肷

// RtBM[VP̐ݒ
#pragma config FOSC     = INTOSC   // ۯgp(INTOSC)
#pragma config WDTE     = OFF      // ޯϰ(OFF)
#pragma config PWRTE    = ON       // dON64ms۸тJn(ON)
#pragma config MCLRE    = OFF      // OؾĐM͎gp޼ٓ(RA3)݂Ƃ(OFF)
#pragma config CP       = OFF      // ۸ذی삵Ȃ(OFF)
#pragma config CPD      = OFF      // ްذی삵Ȃ(OFF)
#pragma config BOREN    = ON       // dd~펞Ď@\ON(ON)
#pragma config CLKOUTEN = OFF      // CLKOUT݂RA4݂Ŏgp(OFF)
#pragma config IESO     = OFF      // OEۯ̐ؑւł̋N͂Ȃ(OFF)
#pragma config FCMEN    = OFF      // OۯĎȂ(OFF)

// RtBM[VQ̐ݒ
#pragma config WRT    = OFF        // Flashذی삵Ȃ(OFF)
#pragma config PLLEN  = OFF        // NbN32MHzł͓삳Ȃ(OFF)
#pragma config STVREN = ON         // X^bNI[ot[A_[t[烊Zbg(ON)
#pragma config BORV   = HI         // dd~펞Ďd(2.5V)ݒ(HI)
#pragma config LVP    = OFF        // dvO~O@\gpȂ(OFF)

/*******************************************************************************
*  荞݂̏                                                              *
*******************************************************************************/
void interrupt InterFunction( void )
{
     InterI2C() ;             // hQb֘Å荞ݏ
}
/*******************************************************************************
*  DACout(adres,value)                                                         *
*    D/ARo[^Ƀf[^o͂鏈iEEPROMɂ͏܂Ȃj               *
*                                                                              *
*    adres : o͂foCX̃AhXw肵܂(0x60/0x61)                 *
*    value : o͂d̃Xebvw肵܂(0-4095)                      *
*******************************************************************************/
void DACout(char adres,int value)
{
     union {
          char c[2] ;
          int  i ;
     } dt ;
     int  ans ;

     dt.i = value ;
     ans = I2C_Start(adres,RW_0);       // X^[gRfBVƃAhX𔭍s
     if (ans == 0) {
          I2C_Send(dt.c[1] & 0x0f) ;    // "Fast Mode","Normal Mode","data(D11-D8)"
          I2C_Send(dt.c[0]) ;           // data(D7-D0)
     }
     I2C_Stop() ;                       // XgbvRfBV𔭍s
}
/*******************************************************************************
*  DACpowerdown(adres,stage)                                                   *
*    D/ARo[^p[_E鏈iEEPROMɂ͏܂Ȃj             *
*                                                                              *
*    adres : o͂foCX̃AhXw肵܂(0x60/0x61)                 *
*    stage : p[_EiKw肵܂(1/2/3)                         *
*            P1K̕גRɂGNDɐݒuꍇɎw                   *
*            Q100K̕גRɂGNDɐݒuꍇɎw                 *
*            R500K̕גRɂGNDɐݒuꍇɎw                 *
*******************************************************************************/
void DACpowerdown(char adres,char stage)
{
     int  ans ;

     ans = I2C_Start(adres,RW_0);  // X^[gRfBVƃAhX𔭍s
     if (ans == 0) {
          I2C_Send(stage<<4) ;     // "Fast Mode","PowerDown Mode","data(D11-D8)"
          I2C_Send(0x00) ;         // data(D7-D0)  data͂OƂ
     }
     I2C_Stop() ;                  // XgbvRfBV𔭍s
}
/*******************************************************************************
*  C̏                                                                *
*******************************************************************************/
void main()
{
     OPTION_REG = 0b00000000 ;     // fW^I/OɓvAbvRgp
     OSCCON = 0b01110010 ;         // NbN8lgƂ
     ANSELA = 0b00000000 ;         // AiO͎gpȂiׂăfW^I/OɊĂj
     TRISA  = 0b00000110 ;         // sRA1(SCL)/RA2(SDA)̂ݓ(RA3͓͐p)
     WPUA   = 0b00000110 ;         // RA1/RA2͓vAbvR(I2Cp)w肷
     PORTA  = 0b00000000 ;         // o̓s̏(SLOWɂ)

     InitI2C_Master(0) ;           // hQb̏(100KHz̒ʐMx)
     __delay_ms(5000) ;
     DACout(DAC_ADRES,4095) ;      // DAC4095(5V)o͂(LEDS)
     __delay_ms(5000) ;
     DACpowerdown(DAC_ADRES,3) ;   // DACp[_E(LED)
     while(1) {
     }
}
